﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Data.SqlClient;
using System.Web.UI;
using System.IO;

/// <summary>
/// Servicios de permanencia
/// </summary>
public class PermServ
{
    SqlConnection co;
    Peri_t peri;
    public String dbms;

	public PermServ()
	{
        String cs = System.Configuration.ConfigurationManager.AppSettings["ConnectionString"];
        co = new SqlConnection(cs);
	}
    public String getCort()
    {
        String cort=null;
        getPeri();
        DateTime now = DateTime.Now;
        if (now > peri.fina) cort = "3";
        else if (now > peri.cor2) cort = "2";
        else if (now > peri.cor1) cort = "1";
        return cort;
    }
    public Peri_t getPeri()
    {
        if (peri == null)
        {
            co.Open();
            SqlCommand cm = new SqlCommand("select t_peri.id,t_peri.codi,t_peri.inic,t_peri.fina,t_peri.cor1,t_peri.cor2 from t_peri, t_parm where t_peri.codi=t_parm.valo and t_parm.nomb='peri.acti'", co);
            SqlDataReader dr = cm.ExecuteReader();
            if (dr.Read())
            {
                int j = 0;
                peri = new Peri_t();
                peri.id = dr.GetValue(j).ToString(); j++;
                peri.codi = dr.GetValue(j).ToString(); j++;
                peri.inic = dr.GetDateTime(j); j++;
                peri.fina = dr.GetDateTime(j); j++;
                peri.cor1 = dr.GetDateTime(j); j++;
                peri.cor2 = dr.GetDateTime(j); j++;
            }
            dr.Close();
            co.Close();
            if (peri == null) throw new Exception("No definido un periodo activo!");
        }
        return peri;
    }
    public String valUsua(String u, String c)
    {
        String id = null;
        Pers_t pers = getPersByDocu(u);
        if (pers != null && c == pers.celu)
        {
            id = pers.id;
        }
        return id;
    }
    public Usua_t getUsua(String id)
    {
        Usua_t usua = null;
        Pers_t pers = getPersByID(id);
        if (pers != null)
        {
            usua = new Usua_t();
            usua.id = pers.id;
            usua.nomb = pers.apel + " " + pers.nomb;
            usua.plnk = pers.plnk;
        }
        if (usua != null)
        {
            if (execSql("select id from t_prof_peri where idpers=" + pers.id + " and idperi=" + getPeri().id) != null) usua.esprof = true;
            if (execSql("select id from t_pers_serv where idpers=" + pers.id) != null) usua.esapoy = true;
        }
        return usua;
    }
    public Pers_t getPersByDocu(String docu)
    {
        return getPersBySql("docu='" + docu + "'");
    }
    public Pers_t getPersByID(String id)
    {
        return getPersBySql("id='" + id + "'");
    }
    public Pers_t getPersBySql(String q)
    {
        Pers_t pers = null;
        co.Open();
        SqlCommand cm = new SqlCommand("select id,docu,nomb,apel,celu,plnk from t_pers where " + q, co);
        SqlDataReader dr = cm.ExecuteReader();
        if(dr.Read())
        {
            int j = 0;
            pers = new Pers_t();
            pers.id = dr.GetValue(j).ToString(); j++;
            pers.docu = dr.GetValue(j).ToString(); j++;
            pers.nomb = dr.GetValue(j).ToString(); j++;
            pers.apel = dr.GetValue(j).ToString(); j++;
            pers.celu = dr.GetValue(j).ToString(); j++;
            pers.plnk = dr.GetValue(j).ToString(); j++;
        }
        co.Close();
        return pers;
    }
    String execSql(String sql)
    {
        String resu = null;
        co.Open();
        SqlCommand cm = new SqlCommand(sql, co);
        SqlDataReader dr = cm.ExecuteReader();
        if (dr.Read())
        {
            resu = dr.GetValue(0).ToString();
        }
        co.Close();
        return resu;
    }
    public Curs_t getCurs(String id)
    {
        Curs_t curs = null;
        co.Open();
        SqlCommand cm = new SqlCommand("select t_curs.id,t_curs.idasig,t_curs.hora,t_asig.nomb from t_curs inner join t_asig on t_curs.idasig=t_asig.id where t_curs.id=" + id, co);
        SqlDataReader dr = cm.ExecuteReader();
        while (dr.Read())
        {
            int j = 0;
            curs = new Curs_t();
            curs.id = dr.GetValue(j).ToString(); j++;
            curs.idasig = dr.GetValue(j).ToString(); j++;
            curs.hora = dr.GetValue(j).ToString(); j++;
            curs.nmAsig = dr.GetValue(j).ToString(); j++;
        }
        dr.Close();
        co.Close();
        return curs;
    }
    public List<Curs_t> getCursByProf(String id)
    {
        List<Curs_t> crss = new List<Curs_t>();
        co.Open();
        SqlCommand cm = new SqlCommand("select t_curs.id,t_curs.idasig,t_curs.hora,t_asig.nomb from t_curs inner join t_asig on t_curs.idasig=t_asig.id inner join t_prof_peri on t_curs.idprofperi=t_prof_peri.id where t_prof_peri.idpers=" + id + " and t_curs.idperi=" + getPeri().id, co);
        SqlDataReader dr = cm.ExecuteReader();
        while(dr.Read())
        {
            int j = 0;
            Curs_t curs = new Curs_t();
            curs.id = dr.GetValue(j).ToString(); j++;
            curs.idasig = dr.GetValue(j).ToString(); j++;
            curs.hora = dr.GetValue(j).ToString(); j++;
            curs.nmAsig = dr.GetValue(j).ToString(); j++;
            crss.Add(curs);
        }
        dr.Close();
        co.Close();
        return crss;
    }
    public CursClas_t getCursClas(String id)
    {
        CursClas_t clas = null;
        co.Open();
        SqlCommand cm = new SqlCommand("select t_curs_clas.id,t_curs_clas.fech,t_asig.nomb,t_curs.hora,t_curs.id from t_curs_clas inner join t_curs on t_curs_clas.idcurs=t_curs.id inner join t_asig on t_curs.idasig=t_asig.id where t_curs_clas.id=" + id, co);
        SqlDataReader dr = cm.ExecuteReader();
        while (dr.Read())
        {
            int j = 0;
            clas = new CursClas_t();
            clas.id = dr.GetValue(j).ToString(); j++;
            clas.fech = dr.GetValue(j).ToString(); j++;
            clas.nmAsig = dr.GetValue(j).ToString(); j++;
            clas.hora = dr.GetValue(j).ToString(); j++;
            clas.idcurs = dr.GetValue(j).ToString(); j++;
        }
        dr.Close();
        co.Close();
        return clas;
    }
    public List<CursClas_t> getCursClss(String id)
    {
        List<CursClas_t> clss = new List<CursClas_t>();
        co.Open();
        SqlCommand cm = new SqlCommand("select id,fech,idcurs from t_curs_clas where idcurs=" + id, co);
        SqlDataReader dr = cm.ExecuteReader();
        while (dr.Read())
        {
            int j = 0;
            CursClas_t clas = new CursClas_t();
            clas.id = dr.GetValue(j).ToString(); j++;
            clas.fech = dr.GetValue(j).ToString(); j++;
            clas.idcurs = dr.GetValue(j).ToString(); j++;
            clss.Add(clas);
        }
        dr.Close();
        co.Close();
        return clss;
    }
    public List<EstuCurs_t> getEstuCursAllByPers(String id)
    {
        return getEstuCursBySql("t_estu_peri.idpers = " + id + " order by t_peri.codi");
    }
    public List<EstuCurs_t> getEstuCursByClas(String id)
    {
        return getEstuCursBySql("t_estu_curs.idcurs = (select idcurs from t_curs_clas where id=" + id + ")");
    }
    public List<EstuCurs_t> getEstuCursByCurs(String id)
    {
        return getEstuCursBySql("t_estu_curs.idcurs=" + id);
    }
    List<EstuCurs_t> getEstuCursBySql(String w)
    {
        List<EstuCurs_t> ecs = new List<EstuCurs_t>();
        co.Open();
        SqlCommand cm = new SqlCommand("select t_estu_curs.id,t_estu_curs.idestuperi,t_estu_curs.idcurs,t_pers.apel+' '+t_pers.nomb,t_estu_curs.cor1,t_estu_curs.cor2,t_estu_curs.defi,t_peri.codi,t_asig.nomb,t_pers2.apel+' '+t_pers2.nomb,t_curs.hora from t_estu_curs inner join t_curs on t_estu_curs.idcurs=t_curs.id inner join t_estu_peri on t_estu_curs.idestuperi=t_estu_peri.id inner join t_pers on t_estu_peri.idpers=t_pers.id inner join t_peri on t_estu_peri.idperi=t_peri.id inner join t_asig on t_curs.idasig=t_asig.id inner join t_prof_peri on t_curs.idprofperi=t_prof_peri.id inner join t_pers t_pers2 on t_prof_peri.idpers=t_pers2.id where " + w, co);
        SqlDataReader dr = cm.ExecuteReader();
        while (dr.Read())
        {
            int j = 0;
            EstuCurs_t ec = new EstuCurs_t();
            ec.id = dr.GetValue(j).ToString(); j++;
            ec.idestuperi = dr.GetValue(j).ToString(); j++;
            ec.idcurs = dr.GetValue(j).ToString(); j++;
            ec.nmEstu = dr.GetValue(j).ToString(); j++;
            ec.cor1 = dr.GetValue(j).ToString(); j++;
            ec.cor2 = dr.GetValue(j).ToString(); j++;
            ec.defi = dr.GetValue(j).ToString(); j++;
            ec.peri = dr.GetValue(j).ToString(); j++;
            ec.asig = dr.GetValue(j).ToString(); j++;
            ec.prof = dr.GetValue(j).ToString(); j++;
            ec.hora = dr.GetValue(j).ToString(); j++;
            ecs.Add(ec);
        }
        dr.Close();
        co.Close();
        return ecs;
    }
    public void pobCursClasInas(List<EstuCurs_t> ecs, String idclas)
    {
        Dictionary<String, String> inas = new Dictionary<string, string>();
        {
            co.Open();
            SqlCommand cm = new SqlCommand("select id,idestucurs from t_curs_clas_inas where idclas=" + idclas, co);
            SqlDataReader dr = cm.ExecuteReader();
            while (dr.Read())
            {
                inas.Add(dr.GetValue(1).ToString(), dr.GetValue(0).ToString());
            }
            dr.Close();
            co.Close();
        }
        foreach (EstuCurs_t ec in ecs)
        {
            ec.inas=inas.ContainsKey(ec.id);
            if (ec.inas)
            {
                ec.idinas = inas[ec.id];
            }
        }
    }
    public void savCursClasInas(List<EstuCurs_t> ecs,String idclas)
    {
        co.Open();
        foreach (EstuCurs_t ec in ecs)
        {
            if (ec.idinas == null && ec.inas)
            {
                SqlCommand cm = new SqlCommand("insert into t_curs_clas_inas(idclas,idestucurs)values(" + idclas + "," + ec.id + ")", co);
                cm.ExecuteNonQuery();
            }
            if (ec.idinas != null && !ec.inas)
            {
                SqlCommand cm = new SqlCommand("delete from t_curs_clas_inas where id=" + ec.idinas, co);
                cm.ExecuteNonQuery();
            }
        }
        co.Close();
    }
    public void genPlnk(String id)
    {
        co.Open();
        SqlCommand cm = new SqlCommand("update t_pers set plnk=newid() where id=" + id, co);
        cm.ExecuteNonQuery();
        co.Close();
    }
    public Plnk_t getPlnk(String id)
    {
        String idpe = getPeri().id;
        Plnk_t plnk = null;
        co.Open();
        SqlCommand cm = new SqlCommand("select t_curs_clas.id,t_pers.id from t_curs_clas inner join t_curs on t_curs_clas.idcurs=t_curs.id inner join t_prof_peri on t_curs.idprofperi=t_prof_peri.id inner join t_pers on t_prof_peri.idpers=t_pers.id where t_pers.plnk='" + id + "' and t_prof_peri.idperi=" + idpe + " and t_curs_clas.fech<getdate() and getdate()<dateadd(hh,1,t_curs_clas.fech)", co);
        SqlDataReader dr = cm.ExecuteReader();
        if(dr.Read())
        {
            int j = 0;
            plnk = new Plnk_t();
            plnk.idclas = dr.GetValue(j).ToString(); j++;
            plnk.idpers = dr.GetValue(j).ToString(); j++;
        }
        dr.Close();
        co.Close();
        return plnk;
    }
    public void savNota(List<EstuCurs_t> ecs, String cort)
    {
        co.Open();
        String notn = null;
        String notv = null;
        if (cort == "1") notn = "cor1";
        else if (cort == "2") notn = "cor2";
        else if (cort == "3") notn = "defi";
        foreach (EstuCurs_t ec in ecs)
        {
            if (cort == "1") notv = ec.cor1;
            else if (cort == "2") notv = ec.cor2;
            else if (cort == "3") notv = ec.defi;
            SqlCommand cm = new SqlCommand("update t_estu_curs set " + notn + "='" + notv + "' where id=" + ec.id, co);
            cm.ExecuteNonQuery();
        }
        co.Close();
    }
    public FormCont_t getContByEstuPeri(String form, String espe, String pese, String peri)
    {
        co.Open();
        FormCont_t cont = new FormCont_t();
        cont.idform = form;
        cont.idpersserv = pese;
        cont.idestuperi = espe;
        cont.idperi = peri;
        {
            SqlCommand cm = new SqlCommand("select id from t_form_cont where idpersserv=@pese and t_form_cont.idform=@form and t_form_cont.idperi=@peri", co);
            cm.Parameters.AddWithValue("@pese", cont.idpersserv);
            cm.Parameters.AddWithValue("@form", cont.idform);
            cm.Parameters.AddWithValue("@espe", cont.idestuperi);
            cm.Parameters.AddWithValue("@peri", cont.idperi);
            SqlDataReader dr = cm.ExecuteReader();
            if (dr.Read())
            {
                cont.idcont = dr.GetValue(0).ToString();
            }
            dr.Close();
        }
        if (cont.idcont == null)
        {
            SqlCommand cm = new SqlCommand("insert into t_form_cont(idpersserv,idestuperi,idform,idperi,fech)values(@pese,@espe,@form,@peri,getdate())", co);
            cm.Parameters.AddWithValue("@pese", cont.idpersserv);
            cm.Parameters.AddWithValue("@espe", cont.idpersserv);
            cm.Parameters.AddWithValue("@form", cont.idform);
            cm.Parameters.AddWithValue("@peri", cont.idperi);
            cm.ExecuteNonQuery();
            cont.idcont = getiden();
        }
        loadcont(cont);
        co.Close();
        return cont;
    }
    public FormCont_t getContById(String id)
    {
        co.Open();
        FormCont_t cont = null;
        {
            SqlCommand cm = new SqlCommand("select id,idform from t_form_cont where id=@idco", co);
            cm.Parameters.AddWithValue("@idco", id);
            SqlDataReader dr = cm.ExecuteReader();
            if (dr.Read())
            {
                cont = new FormCont_t();
                cont.idcont = dr.GetValue(0).ToString();
                cont.idform = dr.GetValue(1).ToString();
            }
            dr.Close();
        }
        if (cont != null)
        {
            loadcont(cont);
        }
        co.Close();
        return cont;
    }
    public FormCont_t newCont(String espe, String form, String pese)
    {
        FormCont_t cont = new FormCont_t();
        cont.idform = form;
        cont.idestuperi = espe;
        cont.idpersserv = pese;
        cont.idperi = getPeri().id;
        co.Open();
        {
            SqlCommand cm = new SqlCommand("select p.id,p.preg,p.tipo,p.opci,p.cond from t_form_preg p where idform=@form order by p.orde", co);
            cm.Parameters.AddWithValue("@form", cont.idform);
            SqlDataReader dr = cm.ExecuteReader();
            while (dr.Read())
            {
                int j = 0;
                FormPreg_t p = new FormPreg_t();
                p.idpreg = dr.GetValue(j).ToString(); j++;
                p.preg = dr.GetValue(j).ToString(); j++;
                p.tipo = dr.GetValue(j).ToString(); j++;
                p.opco = dr.GetValue(j).ToString(); j++;
                p.cond = dr.GetValue(j).ToString(); j++;
                cont.prgs.Add(p.idpreg, p);
            }
            dr.Close();
        }
        co.Close();
        return cont;
    }
    void loadcont(FormCont_t cont)
    {
        {
            SqlCommand cm = new SqlCommand("select p.id,p.preg,p.tipo,p.opci,r.id,r.resp,p.cond from (select id,preg,tipo,opci,cond,orde from t_form_preg p where idform=@form) p left join (select id,idpreg,resp from t_form_resp where idcont=@cont) r on p.id=r.idpreg order by p.orde", co);
            cm.Parameters.AddWithValue("@form", cont.idform);
            cm.Parameters.AddWithValue("@cont", cont.idcont);
            SqlDataReader dr = cm.ExecuteReader();
            while (dr.Read())
            {
                int j = 0;
                FormPreg_t p = new FormPreg_t();
                p.idpreg = dr.GetValue(j).ToString(); j++;
                p.preg = dr.GetValue(j).ToString(); j++;
                p.tipo = dr.GetValue(j).ToString(); j++;
                p.opco = dr.GetValue(j).ToString(); j++;
                p.idresp = dr.GetValue(j).ToString(); j++;
                p.resp = dr.GetValue(j).ToString(); j++;
                p.cond = dr.GetValue(j).ToString(); j++;
                cont.prgs.Add(p.idpreg, p);
            }
            dr.Close();
        }
    }
    public void savCont(FormCont_t cont, HttpRequest rq, Page pg)
    {
        co.Open();
        if (cont.idcont == null)
        {
            SqlCommand cm = new SqlCommand("insert into t_form_cont(idform,idestuperi,idpersserv,idperi,fech)values(@form,@espe,@pese,@peri,getdate())", co);
            cm.Parameters.AddWithValue("@form", cont.idform);
            cm.Parameters.AddWithValue("@espe", cont.idestuperi);
            cm.Parameters.AddWithValue("@pese", cont.idpersserv);
            cm.Parameters.AddWithValue("@peri", cont.idperi);
            cm.ExecuteNonQuery();
            cont.idcont = getiden();
        }
        {
            SqlCommand cm = new SqlCommand("update t_form_resp set resp=@resp where id=@idresp", co);
            cm.Parameters.Add("@idresp", System.Data.SqlDbType.NVarChar);
            cm.Parameters.Add("@resp", System.Data.SqlDbType.NVarChar);
            foreach (FormPreg_t p in cont.prgs.Values)
            {
                if (p.idresp == "" || p.idresp == null) continue;
                cm.Parameters["@idresp"].Value = p.idresp;
                cm.Parameters["@resp"].Value = p.resp;
                cm.ExecuteNonQuery();
            }
        }
        {
            SqlCommand cm = new SqlCommand("insert into t_form_resp(idcont,idpreg,resp)values(@idcont,@idpreg,@resp)", co);
            cm.Parameters.Add("@idcont", System.Data.SqlDbType.NVarChar);
            cm.Parameters.Add("@idpreg", System.Data.SqlDbType.NVarChar);
            cm.Parameters.Add("@resp", System.Data.SqlDbType.NVarChar);
            foreach (FormPreg_t p in cont.prgs.Values)
            {
                if (!(p.idresp == "" || p.idresp == null)) continue;
                cm.Parameters["@idcont"].Value = cont.idcont;
                cm.Parameters["@idpreg"].Value = p.idpreg;
                cm.Parameters["@resp"].Value = p.resp;
                cm.ExecuteNonQuery();
                p.idresp = getiden();
            }
        }
        co.Close();
        foreach (FormPreg_t p in cont.prgs.Values)
        {
            String k = "f" + p.idpreg;
            if (p.tipo == "PDF" && rq.Files[k] != null && rq.Files[k].FileName != "")
            {
                rq.Files[k].SaveAs(pg.MapPath("docs/" + cont.idcont + "-" + p.idpreg + ".pdf"));
                p.resp = "OK";
            }
            else if (p.tipo == "JPG" && rq.Files[k] != null && rq.Files[k].FileName != "")
            {
                rq.Files[k].SaveAs(pg.MapPath("docs/" + cont.idcont + "-" + p.idpreg + ".jpg"));
                p.resp = "OK";
            }
        }
    }
    String getiden()
    {
        String id = null;
        SqlCommand cm = new SqlCommand("select @@identity", co);
        SqlDataReader dr = cm.ExecuteReader();
        if (dr.Read())
        {
            id = dr.GetValue(0).ToString();
        }
        dr.Close();
        return id;
    }
    public String bldForm(FormCont_t cont)
    {
        bldCond(cont);
        String html = "<table border=\"1\">";
        foreach (FormPreg_t p in cont.prgs.Values)
        {
            if (p.visi != null)
            {
                if (p.tipo == "TITULO")
                {
                    html += "<tr><td colspan=\"2\" style=\"background-color:blue;color:white;text-align:center;\">" + p.preg + "</td></tr>";
                }
                else
                {
                    html += "<tr><td>" + p.preg + "</td><td>";
                    if (p.tipo == "MENSAJE")
                    {
                        html += p.resp;
                    }
                    else if (p.tipo == "URL")
                    {
                        html += "Por favor visite el siguiente formulario<br/><button onclick=\"window.open('" + p.opci + "');setTimeout('document.getElementById(&quot;btsubmit&quot;).click();',0);\">Formulario</button>";
                    }
                    else if (p.tipo == "TEXTO")
                    {
                        html += "<input type=\"text\" name=\"f" + p.idpreg + "\" value=\"" + p.resp + "\" />";
                    }
                    else if (p.tipo == "AREATEXTO")
                    {
                        html += "<textarea rows=\"4\" cols=\"90\" name=\"f" + p.idpreg + "\" >";
                        html += p.resp;
                        html += "</textarea>";
                    }
                    else if (p.tipo == "NUMERO")
                    {
                        html += "<input type=\"text\" name=\"f" + p.idpreg + "\" value=\"" + p.resp + "\" />";
                    }
                    else if (p.tipo == "LISTA")
                    {
                        html += "<select name=\"f" + p.idpreg + "\" ";
                        if (p.pstb != null) html += "onchange=\"setTimeout('document.forms[&quot;form1&quot;].submit();', 0)\"";
                        html += ">";
                        foreach (string s in p.opci.Split(','))
                        {
                            html += "<option";
                            if (s == p.resp) html += " selected";
                            html += " >" + s + "</option>";
                        }
                        html += "</select>";
                    }
                    else if (p.tipo == "FECHA")
                    {
                        String[] ff = p.resp.Split('-');
                        String dd = "";
                        String mm = "";
                        String aa = "";
                        if (ff.Length > 0) dd = ff[0];
                        if (ff.Length > 1) mm = ff[1];
                        if (ff.Length > 2) aa = ff[2];
                        html += "<select name=\"f" + p.idpreg + "-dd\" >";
                        for (int i = 1; i <= 31; i++)
                        {
                            html += "<option";
                            if (i.ToString() == dd) html += " selected";
                            html += " >" + i + "</option>";
                        }
                        html += "</select>";
                        html += " - ";
                        html += "<select name=\"f" + p.idpreg + "-mm\" >";
                        for (int i = 1; i <= 12; i++)
                        {
                            html += "<option";
                            if (i.ToString() == mm) html += " selected";
                            html += " >" + i + "</option>";
                        }
                        html += "</select>";
                        html += " - ";
                        html += "<select name=\"f" + p.idpreg + "-aa\" >";
                        for (int i = 0; i <= 100; i++)
                        {
                            String a2 = DateTime.Now.AddYears(i * -1).Year.ToString();
                            html += "<option";
                            if (a2 == aa) html += " selected";
                            html += " >" + a2 + "</option>";
                        }
                        html += "</select>";
                    }
                    else if (p.tipo == "PDF")
                    {
                        if (p.resp != "") html += "<a href=\"verdoc.aspx?ID=" + cont.idcont + ":" + p.idpreg + "\" >Ver</a>";
                        html += "<input type=\"file\" name=\"f" + p.idpreg + "\" value=\"" + "\" /> (Subir archivos PDF)";
                    }
                    else if (p.tipo == "JPG")
                    {
                        if (p.resp != "") html += "<a href=\"verdoc.aspx?ID=" + cont.idcont + ":" + p.idpreg + ":j\" >Ver</a>";
                        html += "<input type=\"file\" name=\"f" + p.idpreg + "\" value=\"" + "\" /> (Subir archivos JPG)";
                    }
                    html += "</td></tr>";
                }
            }
        }
        html += "</table>";
        return html;
    }
    public void loadForm(FormCont_t cont, HttpRequest rq, Page pg)
    {
        foreach (FormPreg_t p in cont.prgs.Values)
        {
            if (p.tipo == "PDF")
            {
                if (File.Exists(pg.MapPath("docs/" + cont.idcont + "-" + p.idpreg + ".pdf"))) p.resp = "OK";
            }
            else if (p.tipo == "FECHA")
            {
                String dd = rq.Form["f" + p.idpreg + "-dd"];
                String mm = rq.Form["f" + p.idpreg + "-mm"];
                String aa = rq.Form["f" + p.idpreg + "-aa"];
                if (dd != null && mm != null && aa != null) p.resp = dd + "-" + mm + "-" + aa;
            }
            else
            {
                String s = rq.Form["f" + p.idpreg];
                if (s != null) p.resp = s;
            }
        }
    }
    void bldCond(FormCont_t cont)
    {
        foreach (FormPreg_t p in cont.prgs.Values)
        {
            if (p.cond != "")
            {
                if (evlCond(cont, p.cond)) p.visi = "OK";
            }
            else
            {
                p.visi = "OK";
            }
            p.opci = "";
            {
                bool cond = true;
                foreach (String s in p.opco.Split(','))
                {
                    String s2 = s.Trim();
                    if (s2.Length == 0 || s2[0] != '(')
                    {
                        if (cond)
                        {
                            if (p.opci != "") p.opci += ",";
                            p.opci += s2;
                        }
                    }
                    else
                    {
                        cond = evlCond(cont, s2.Replace('(', ' ').Replace(')', ' ').Trim());
                    }
                }
            }
        }
    }
    bool evlCond(FormCont_t cont, String s)
    {
        bool b = false;
        String o = "";
        foreach (String c in s.Split(';'))
        {
            if (c != "+")
            {
                if (b && o != "+") break;
                String[] vv = c.Split(':');
                FormPreg_t p2 = cont.prgs[vv[0]];
                p2.pstb = "OK";
                b = (p2.resp == vv[1]) && (o == "+" ? b : true);
            }
            o = c;
        }
        return b;
    }
    public List<ServRemi_t> getRemiByPers(String pers)
    {
        List<ServRemi_t> rems = new List<ServRemi_t>();
        co.Open();
        SqlCommand cm = new SqlCommand("select t_serv_remi.id,t_serv_remi.obse,t_serv_remi.inic,t_pers.apel+' '+t_pers.nomb,t_pers2.apel+' '+t_pers2.nomb,t_serv_remi.idestuperi from t_serv_remi inner join t_pers_serv on t_serv_remi.idpersserv=t_pers_serv.id inner join t_pers on t_pers_serv.idpers=t_pers.id inner join t_estu_peri on t_serv_remi.idestuperi=t_estu_peri.id inner join t_pers t_pers2 on t_estu_peri.idpers=t_pers2.id where fech is null and t_serv_remi.idserv in (select idserv from t_pers_serv where idpers=" + pers + ")", co);
        SqlDataReader dr = cm.ExecuteReader();
        while(dr.Read())
        {
            ServRemi_t r = new ServRemi_t();
            int j = 0;
            r.id = dr.GetValue(j).ToString(); j++;
            r.obse = dr.GetValue(j).ToString(); j++;
            r.inic = dr.GetValue(j).ToString(); j++;
            r.nmpers = dr.GetValue(j).ToString(); j++;
            r.nmestu = dr.GetValue(j).ToString(); j++;
            r.idestuperi = dr.GetValue(j).ToString(); j++;
            rems.Add(r);
        }
        dr.Close();
        co.Close();
        return rems;
    }
    public ServRemi_t getRemiByID(String id)
    {
        ServRemi_t remi = null;
        co.Open();
        SqlCommand cm = new SqlCommand("select t_serv_remi.id,t_serv_remi.idestuperi from t_serv_remi where t_serv_remi.fech is null and t_serv_remi.id=" + id, co);
        SqlDataReader dr = cm.ExecuteReader();
        while (dr.Read())
        {
            remi = new ServRemi_t();
            int j = 0;
            remi.id = dr.GetValue(j).ToString(); j++;
            remi.idestuperi = dr.GetValue(j).ToString(); j++;
        }
        dr.Close();
        co.Close();
        return remi;
    }
    public List<PersServ_t> getPersServByPers(String pers)
    {
        List<PersServ_t> srvs = new List<PersServ_t>();
        co.Open();
        SqlCommand cm = new SqlCommand("select t_pers_serv.id,t_serv.id,t_serv.nomb,t_serv.idform from t_pers_serv inner join t_serv on t_pers_serv.idserv=t_serv.id where t_pers_serv.idpers=@pers", co);
        cm.Parameters.AddWithValue("@pers",pers);
        SqlDataReader dr = cm.ExecuteReader();
        while(dr.Read())
        {
            PersServ_t s = new PersServ_t();
            int j = 0;
            s.id = dr.GetValue(j).ToString(); j++;
            s.idserv = dr.GetValue(j).ToString(); j++;
            s.nomb = dr.GetValue(j).ToString(); j++;
            s.idform = dr.GetValue(j).ToString(); j++;
            srvs.Add(s);
        }
        dr.Close();
        co.Close();
        return srvs;
    }
    public PersServ_t getPersServByID(String id)
    {
        PersServ_t ps = null;
        co.Open();
        SqlCommand cm = new SqlCommand("select t_pers_serv.id,t_serv.id,t_serv.nomb,t_serv.idform from t_pers_serv inner join t_serv on t_pers_serv.idserv=t_serv.id where t_pers_serv.id=@id", co);
        cm.Parameters.AddWithValue("@id", id);
        SqlDataReader dr = cm.ExecuteReader();
        while (dr.Read())
        {
            ps = new PersServ_t();
            int j = 0;
            ps.id = dr.GetValue(j).ToString(); j++;
            ps.idserv = dr.GetValue(j).ToString(); j++;
            ps.nomb = dr.GetValue(j).ToString(); j++;
            ps.idform = dr.GetValue(j).ToString(); j++;
        }
        dr.Close();
        co.Close();
        return ps;
    }
    public EstuPeri_t getEstuPeriByDocu(String docu)
    {
        String peri = getPeri().id;
        EstuPeri_t ep = null;
        List<EstuPeri_t> eps = getEstuPeriBySql("t_pers.docu='" + docu + "' and t_estu_peri.idperi=" + peri, "");
        if (eps.Count > 0) ep = eps[0];
        return ep;
    }
    public EstuPeri_t getEstuPeriByID(String id)
    {
        String peri = getPeri().id;
        EstuPeri_t ep = null;
        List<EstuPeri_t> eps = getEstuPeriBySql("t_estu_peri.id='" + id + "' and t_estu_peri.idperi=" + peri, "");
        if (eps.Count > 0) ep = eps[0];
        return ep;
    }
    public List<EstuPeri_t> getEstuPeriAllByPers(String id)
    {
        return getEstuPeriBySql("t_estu_peri.idpers='" + id + "'", " order by t_peri.nomb");
    }
    List<EstuPeri_t> getEstuPeriBySql(String q, String o)
    {
        List<EstuPeri_t> eps = new List<EstuPeri_t>();
        co.Open();
        SqlCommand cm = new SqlCommand("select t_estu_peri.id,t_pers.docu,t_pers.nomb,t_pers.apel,t_pers.celu,t_peri.codi,t_prog.nomb,t_estu_peri.tipo,t_sede.nomb,t_pers.id from t_estu_peri inner join t_pers on t_estu_peri.idpers=t_pers.id inner join t_peri on t_estu_peri.idperi=t_peri.id inner join t_prog on t_estu_peri.idprog=t_prog.id inner join t_sede on t_estu_peri.idsede=t_sede.id where " + q, co);
        SqlDataReader dr = cm.ExecuteReader();
        while (dr.Read())
        {
            int j = 0;
            EstuPeri_t ep = new EstuPeri_t();
            ep.id = dr.GetValue(j).ToString(); j++;
            ep.docu = dr.GetValue(j).ToString(); j++;
            ep.nomb = dr.GetValue(j).ToString(); j++;
            ep.apel = dr.GetValue(j).ToString(); j++;
            ep.celu = dr.GetValue(j).ToString(); j++;
            ep.peri = dr.GetValue(j).ToString(); j++;
            ep.prog = dr.GetValue(j).ToString(); j++;
            ep.tipo = dr.GetValue(j).ToString(); j++;
            ep.sede = dr.GetValue(j).ToString(); j++;
            ep.idpers = dr.GetValue(j).ToString(); j++;
            eps.Add(ep);
        }
        dr.Close();
        co.Close();
        return eps;
    }
    public String infoMatr(String pers)
    {
        String info = "<p>MATRICULA</p><table border='1'>";
        info += "<tr><td>ESTUDIANTE</td><td>PERIODO</td><td>SEDE</td><td>PROGRAMA</td><td>TIPO</td></tr>";
        foreach (EstuPeri_t ep in getEstuPeriAllByPers(pers))
        {
            info += "<tr><td>" + ep.apel + " " + ep.nomb + "</td><td>" + ep.peri + "</td><td>" + ep.sede + "</td><td>" + ep.prog + "</td><td>" + ep.tipo + "</td></tr>";
        }
        info += "</table>";
        return info;
    }
    public String infoAsig(String pers)
    {
        String info = "<p>ASIGNATURAS</p><table border='1'>";
        info += "<tr><td>ESTUDIANTE</td><td>PERIODO</td><td>ASIGNATURA</td><td>PROFESOR</td><td>HORARIO</td><td>DEFINITIVA</td><td>CORTE1</td><td>CORTE2</td></tr>";
        foreach (EstuCurs_t ec in getEstuCursAllByPers(pers))
        {
            info += "<tr><td>" + ec.nmEstu + "</td><td>" + ec.peri + "</td><td>" + ec.asig + "</td><td>" + ec.prof + "</td><td>" + ec.hora + "</td><td>" + ec.defi + "</td><td>" + ec.cor1 + "</td><td>" + ec.cor2 + "</td></tr>";
        }
        info += "</table>";
        return info;
    }
    public String infoRies(String pers)
    {
        String info = "<p>RIESGOS</p><table border='1'>";
        info += "<tr><td>ESTUDIANTE</td><td>PERIODO</td><td>SEMÁFORO</td><td>RIESGO</td></tr>";
        foreach (Ries_t r in getRiesByPers(pers))
        {
            info += "<tr><td>" + r.estu + "</td><td>" + r.peri + "-" + r.subp + "</td><td>" + r.sema + "</td><td>" + r.ries + "</td></tr>";
        }
        info += "</table>";
        return info;
    }
    public List<Ries_t> getRiesByPers(String id)
    {
        List<Ries_t> riss = new List<Ries_t>();
        co.Open();
        SqlCommand cm = new SqlCommand("select t_pers.apel+' '+t_pers.nomb,t_peri.codi,t_ries.sema,t_ries.ries,t_ries.subp from t_ries inner join t_peri on t_ries.idperi=t_peri.id inner join t_estu_peri on t_ries.idestuperi=t_estu_peri.id inner join t_pers on t_estu_peri.idpers=t_pers.id where t_pers.id=" + id + " order by t_peri.codi,t_ries.subp", co);
        SqlDataReader dr = cm.ExecuteReader();
        while(dr.Read())
        {
            int j = 0;
            Ries_t r = new Ries_t();
            r.estu = dr.GetValue(j).ToString(); j++;
            r.peri = dr.GetValue(j).ToString(); j++;
            r.sema = dr.GetValue(j).ToString(); j++;
            r.ries = dr.GetValue(j).ToString(); j++;
            r.subp = dr.GetValue(j).ToString(); j++;
            riss.Add(r);
        }
        dr.Close();
        co.Close();
        return riss;
    }
    public List<FormCont_t> getContByPers(String id, String top)
    {
        List<FormCont_t> cons = new List<FormCont_t>();
        co.Open();
        {
            SqlCommand cm = new SqlCommand("select " + top + " t_form_cont.id,t_form_cont.idform,t_form.nomb,t_pers.apel+' '+t_pers.nomb,t_pers2.apel+' '+t_pers2.nomb,t_peri.codi,t_form_cont.fech from t_form_cont inner join t_form on t_form_cont.idform=t_form.id inner join t_peri on t_form_cont.idperi=t_peri.id inner join t_pers_serv on t_form_cont.idpersserv=t_pers_serv.id inner join t_pers on t_pers_serv.idpers=t_pers.id inner join t_estu_peri on t_form_cont.idestuperi=t_estu_peri.id inner join t_pers t_pers2 on t_estu_peri.idpers=t_pers2.id where t_estu_peri.idpers=@id order by t_form_cont.id desc", co);
            cm.Parameters.AddWithValue("@id", id);
            SqlDataReader dr = cm.ExecuteReader();
            while (dr.Read())
            {
                int j = 0;
                FormCont_t cont = new FormCont_t();
                cont.idcont = dr.GetValue(j).ToString(); j++;
                cont.idform = dr.GetValue(j).ToString(); j++;
                cont.nmform = dr.GetValue(j).ToString(); j++;
                cont.nmpers = dr.GetValue(j).ToString(); j++;
                cont.nmestu = dr.GetValue(j).ToString(); j++;
                cont.peri = dr.GetValue(j).ToString(); j++;
                cont.fech = dr.GetValue(j).ToString(); j++;
                cons.Add(cont);
            }
            dr.Close();
            foreach (FormCont_t cont in cons)
            {
                loadcont(cont);
                cont.resu = "";
                foreach (FormPreg_t p in cont.prgs.Values)
                {
                    cont.resu += "(" + p.preg + ":" + p.resp + ")";
                }
            }
        }
        co.Close();
        return cons;
    }
    public String infoCont(String pers, String top)
    {
        String info = "<p>" + top + " CONTACTOS</p><table border='1'>";
        info += "<tr><td>ESTUDIANTE</td><td>FECHA</td><td>SERVICIO</td><td>PERSONA</td><td>RESUMEN</td></tr>";
        foreach (FormCont_t c in getContByPers(pers, top))
        {
            info += "<tr><td>" + c.nmestu + "</td><td>" + c.fech + "</td><td>" + c.nmform + "</td><td>" + c.nmpers + "</td><td>" + c.resu + "</td></tr>";
        }
        info += "</table>";
        return info;
    }
    public void addRemi(String pers, String estu, String serv, String obse)
    {
        co.Open();
        SqlCommand cm = new SqlCommand("insert into t_serv_remi(idserv,idpersserv,idestuperi,obse,inic)values(@serv,@pers,@estu,@obse,getdate())", co);
        cm.Parameters.Add("@serv", serv);
        cm.Parameters.Add("@pers", pers);
        cm.Parameters.Add("@estu", estu);
        cm.Parameters.Add("@obse", obse);
        cm.ExecuteNonQuery();
        co.Close();
    }
    public List<Serv_t> getServ()
    {
        List<Serv_t> ss = new List<Serv_t>();
        co.Open();
        SqlCommand cm = new SqlCommand("select id,nomb from t_serv order by nomb", co);
        SqlDataReader dr = cm.ExecuteReader();
        while (dr.Read())
        {
            int j = 0;
            Serv_t s = new Serv_t();
            s.id = dr.GetValue(j).ToString(); j++;
            s.nomb = dr.GetValue(j).ToString(); j++;
            ss.Add(s);
        }
        dr.Close();
        co.Close();
        return ss;
    }
    public void updRemi(String remi)
    {
        co.Open();
        SqlCommand cm = new SqlCommand("update t_serv_remi set fech=getdate() where id=" + remi + " and fech is null", co);
        cm.ExecuteNonQuery();
        co.Close();
    }
    public List<Prue_t> getPrueByPers(String id)
    {
        List<Prue_t> prus = new List<Prue_t>();
        String peri = getPeri().id;
        co.Open();
        SqlCommand cm = new SqlCommand("select t_form.id,t_form.nomb,p.fech from t_prue inner join t_form on t_prue.idform=t_form.id LEFT join (select idform,fech from t_form_cont where idestuperi=" + id + " and idperi=" + peri + ") p on t_form.id = p.idform order by t_form.nomb", co);
        SqlDataReader dr = cm.ExecuteReader();
        while(dr.Read())
        {
            int j = 0;
            Prue_t p = new Prue_t();
            p.idform = dr.GetValue(j).ToString(); j++;
            p.nomb = dr.GetValue(j).ToString(); j++;
            if (!dr.IsDBNull(j))
            {
                p.fec1 = dr.GetDateTime(j);
                p.fec2 = ((DateTime)p.fec1).AddMinutes(60);
            }
            j++;
            prus.Add(p);
        }
        dr.Close();
        co.Close();
        return prus;
    }
    public Prue_t getPrueByForm(String id)
    {
        Prue_t prue = null;
        co.Open();
        SqlCommand cm = new SqlCommand("select idpersserv from t_prue where idform=" + id, co);
        SqlDataReader dr = cm.ExecuteReader();
        while (dr.Read())
        {
            int j = 0;
            prue = new Prue_t();
            prue.idpersserv = dr.GetValue(j).ToString(); j++;
        }
        dr.Close();
        co.Close();
        return prue;
    }
}

public class Pers_t
{
    public String id;
    public String docu;
    public String nomb;
    public String apel;
    public String celu;
    public String plnk;
}

public class Usua_t
{
    public String id;
    public String nomb;
    public bool esprof;
    public bool esapoy;
    public String plnk;
}

public class Peri_t
{
    public String id;
    public String codi;
    public DateTime inic;
    public DateTime fina;
    public DateTime cor1;
    public DateTime cor2;
}

public class Curs_t
{
    public String id;
    public String idasig;
    public String hora;
    public String nmAsig;
}

public class CursClas_t
{
    public String id;
    public String fech;
    public String hora;
    public String nmAsig;
    public String idcurs;
}

public class EstuCurs_t
{
    public String id;
    public String idestuperi;
    public String idcurs;
    public String nmEstu;
    public bool inas;
    public String idinas;
    public String cor1;
    public String cor2;
    public String defi;
    public String peri;
    public String asig;
    public String prof;
    public String hora;
}

public class FormCont_t
{
    public String idcont;
    public String idform;
    public String idestuperi;
    public String nmpers;
    public String nmestu;
    public String nmform;
    public String peri;
    public Dictionary<String, FormPreg_t> prgs = new Dictionary<string, FormPreg_t>();
    public String idperi;
    public String idpersserv;
    public String fech;
    public String resu;
}
public class FormPreg_t
{
    public String idpreg;
    public String preg;
    public String tipo;
    public String opci;
    public String opco;
    public String idresp;
    public String resp;
    public String cond;
    public String pstb;
    public String visi;
}

public class ServRemi_t
{
    public String id;
    public String obse;
    public String inic;
    public String fech;
    public String nmpers;
    public String nmestu;
    public String idestuperi;
}

public class PersServ_t
{
    public String id;
    public String nomb;
    public String idform;
    public String idpers;
    public String idserv;
}

public class EstuPeri_t
{
    public String id;
    public String docu;
    public String nomb;
    public String apel;
    public String celu;
    public String peri;
    public String prog;
    public String tipo;
    public String sede;
    public String idpers;
}

public class Ries_t
{
    public String estu;
    public String peri;
    public String sema;
    public String ries;
    public String subp;
}

public class Serv_t
{
    public String id;
    public String nomb;
}

public class Prue_t
{
    public String idform;
    public String nomb;
    public DateTime? fec1;
    public DateTime? fec2;
    public String idpersserv;
}

public class Plnk_t
{
    public String idclas;
    public String idpers;
}