﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class RegistroApoyo : System.Web.UI.Page
{
    PermServ ps = new PermServ();
    Usua_t usua = null;
    EstuPeri_t espe;
    PersServ_t pese;
    FormCont_t cont;
    String form;
    ServRemi_t remi;
    
    protected void Page_Load(object sender, EventArgs e)
    {
        String id = (String)Session["usua"];
        if (id == null)
        {
            Response.Redirect("Default.aspx");
            Response.End();
            return;
        }
        usua = ps.getUsua(id);
        {
            String r = Request.QueryString["R"];
            if (r != null)
            {
                remi = ps.getRemiByID(r);
            }
        }
        if (h0.Value == "" && remi != null)
        {
            espe = ps.getEstuPeriByID(remi.idestuperi);
            if (espe != null)
            {
                h1.Value = espe.id;
                h0.Value = "1";
                pobserv();
            }
        }
        if (h1.Value != "") espe = ps.getEstuPeriByID(h1.Value);
        if (h2.Value != "") pese = ps.getPersServByID(h2.Value);
        if (h0.Value == "2") bldform();
    }
    void bldform()
    {
        cont = ps.newCont(h1.Value, pese.idform,pese.id);
        ps.loadForm(cont, Request, Page);
        form = ps.bldForm(cont);
    }
    public Usua_t getusua()
    {
        return usua;
    }
    public List<ServRemi_t> getrems()
    {
        List<ServRemi_t> rems = new List<ServRemi_t>();
        try
        {
            rems = ps.getRemiByPers(usua.id);
        }
        catch(Exception ex)
        {
            lbmens.Text += ex.Message;
        }
        return rems;
    }
    public EstuPeri_t getestuperi()
    {
        return espe;
    }
    public String getcons()
    {
        return ps.infoCont(espe.idpers, "top(3)");
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        lbmens.Text = "";
        try
        {
            if (h0.Value == "")
            {
                espe = ps.getEstuPeriByDocu(txdocu.Text);
                if (espe == null) throw new Exception("No existe!");
                h0.Value = "1";
                h1.Value = espe.id;
                pobserv();
            }
            else if (h0.Value == "1")
            {
                if (ddserv.SelectedValue == "") throw new Exception("Debe seleccionar un servicio!");
                pese = ps.getPersServByID(ddserv.SelectedValue);
                h0.Value = "2";
                h2.Value = ddserv.SelectedValue;
                bldform();
                pobremi();
            }
            else if (h0.Value == "2")
            {
                ps.savCont(cont,Request,Page);
                if (remi != null)
                {
                    ps.updRemi(remi.id);
                    remi = null;
                }
                String mens = "";
                if (ddremi.SelectedValue != "")
                {
                    ps.addRemi(pese.id, espe.id, ddremi.SelectedValue, txremi.Text);
                    mens = " Remitido!";
                }
                h0.Value = "";
                h1.Value = "";
                h2.Value = "";
                lbmens.Text = "Guardado!" + mens;
            }
        }
        catch (Exception ex)
        {
            lbmens.Text = ex.Message;
        }
    }
    void pobserv()
    {
        ddserv.Items.Clear();
        foreach (PersServ_t s in ps.getPersServByPers(usua.id))
        {
            ddserv.Items.Add(new ListItem(s.nomb, s.id));
        }
    }
    void pobremi()
    {
        ddremi.Items.Clear();
        ddremi.Items.Add("");
        foreach (Serv_t s in ps.getServ())
        {
            ddremi.Items.Add(new ListItem(s.nomb, s.id));
        }
    }
    public PersServ_t getpersserv()
    {
        return pese;
    }
    public String getForm()
    {
        return form;
    }
}