﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class RegistroAsistencia : System.Web.UI.Page
{
    PermServ ps = new PermServ();
    Usua_t usua;
    String idcurs;
    String idclas;
    Curs_t curs;
    CursClas_t clas;

    protected void Page_Load(object sender, EventArgs e)
    {
        {
            String plnk = Request.QueryString["L"];
            if (plnk != null)
            {
                Plnk_t l = ps.getPlnk(plnk);
                if (l != null)
                {
                    Session["usua"] = l.idpers;
                    Response.Redirect("RegistroAsistencia.aspx?A=" + l.idclas);
                }
                else
                {
                    Response.Redirect("Default.aspx");
                }
                Response.End();
                return;
            }
        }
        {
            String id = (String)Session["usua"];
            if (id == null)
            {
                Response.Redirect("Default.aspx");
                Response.End();
                return;
            }
            usua = ps.getUsua(id);
            idcurs = Request.QueryString["C"];
            idclas = Request.QueryString["A"];
            if (Request.Form["btenvi"] != null) savInas();
            if (Request.Form["btgene"] != null) genPlnk();
        }
    }
    public Usua_t getusua()
    {
        return usua;
    }
    public bool muescurs()
    {
        return idcurs == null && idclas == null;
    }
    public bool muesclas()
    {
        return idcurs != null;
    }
    public bool muesestu()
    {
        return idclas != null;
    }
    public Curs_t getcurs()
    {
        if (curs == null) curs = ps.getCurs(idcurs);
        return curs;
    }
    public CursClas_t getclas()
    {
        if (clas == null) clas = ps.getCursClas(idclas);
        return clas;
    }
    public List<Curs_t> getcrss()
    {
        List<Curs_t> crss = ps.getCursByProf(usua.id);
        return crss;
    }
    public List<CursClas_t> getcursclas()
    {
        List<CursClas_t> clss = new List<CursClas_t>();
        if (idcurs != null) clss = ps.getCursClss(idcurs);
        return clss;
    }
    public List<EstuCurs_t> getestucurs()
    {
        List<EstuCurs_t> ecs = new List<EstuCurs_t>();
        if (idclas != null)
        {
            ecs = ps.getEstuCursByClas(idclas);
            ps.pobCursClasInas(ecs, idclas);
        }
        return ecs;
    }
    void savInas()
    {
        if (idclas != null)
        {
            List<EstuCurs_t> ecs = getestucurs();
            foreach (EstuCurs_t ec in ecs)
            {
                ec.inas = Request.Form["inas" + ec.id] != null;
            }
            ps.savCursClasInas(ecs, idclas);
            lbmens.Text = "Grabado!";
        }
    }
    void genPlnk()
    {
        ps.genPlnk(usua.id);
        usua = ps.getUsua(usua.id);
        lbmens.Text = "Generado!";
    }
}